Author Topic: How to avoid unsupported half-height  (Read 1179 times)

0 Members and 1 Guest are viewing this topic.

Offline MobRules

How to avoid unsupported half-height
« on: March 17, 2017, 04:28:35 PM »
Hi! I just returned to Simutrans after having been away for a while :).

Did a couple of games of regular, then downloaded the latest Experimental, because there are so many features in it that I like & missed. The visual display of sloped tiles is incredibly wonkey. Google & these forums led me to figure that's because of this new(?) 'half-height' thing that the regular game supports, but Extended does not.

If this is the reason for my display issues, how do I tell the new-game engine to build a world with the type of slopes it knows how to draw?

Thanks!

Edited to add: I did look in the simuconf.tab for a setting to tell it not to use whatever this 'half-height' thing is, but I couldn't find it.

Offline Vladki

Re: How to avoid unsupported half-height
« Reply #1 on: March 17, 2017, 04:34:08 PM »
Latest nightly builds of experimental and related paksets should be fine with half height. Did you use those? Could you make a screenshot?




Offline MobRules

Re: How to avoid unsupported half-height
« Reply #2 on: March 17, 2017, 04:50:54 PM »
Thanks for the quick response! I was using the release version, rather than the nightly build, but if the current nightly is stable, I'll try that.

(Only recently re-installed Gentoo, so a screenshot will take a bit of work, since I've got to decide what screenshot program to use and get it installed. Which I need to do anyway :) ).

Edited: Heh. The nightly build needs to link to the 3.4.12 version of the glib cxx library, while gentoo's package manager won't install any version more recent than 2.50.2. Looks like this is going to take a bit more work... Edited again -- no, the 2.50.2 was a different library. But still working on resolving versioning issues...)
« Last Edit: March 17, 2017, 05:10:03 PM by MobRules »

Offline MobRules

Re: How to avoid unsupported half-height
« Reply #3 on: March 17, 2017, 05:13:23 PM »
Actually, I think it may just be easier to roll back my main Simutrans to a version that also doesn't support the half-height thing, so that the release version of Simutrans-Extended will work.

What version do I need to roll back to, to get rid of the incompatibility? (Or is there an easier way?)

Thanks!

Edited: D'oh, it's  the release verson of the PakSet that's incompatible, not the release version of Experimental itself. So the nightly build of the Pak-set should fix it. (So, this was a Pak-set specific issue all along. Nevermind!
« Last Edit: March 17, 2017, 06:42:38 PM by MobRules »

Offline Vladki

Re: How to avoid unsupported half-height
« Reply #4 on: March 17, 2017, 08:40:05 PM »
The release version of experimental is so old that there is no sense to even try it. By all means use nightly. If you use gentoo, you might be able to compile from sources to avoid any dependency hell. If you play simutrans standard as well, keep it separated from extended. Each has its own paksets and configuration




Offline MobRules

Re: How to avoid unsupported half-height
« Reply #5 on: March 17, 2017, 09:22:42 PM »
Yup, I think I am going to have to compile from sources -- I can't get around the fact that the simutrans-ex nightly build wants a much older version of the library than I have (or could even find to download directly into the folder.)

(After not getting the linux binary download to work, I tried the .deb with deb2targz to convert it.)

Offline jamespetts

  • Simitrans-Extended project coordinator
  • Moderator
  • *
  • Posts: 15557
  • Total likes: 383
  • Helpful: 172
  • Cake baker
    • Bridgewater-Brunel
  • Languages: EN
Re: How to avoid unsupported half-height
« Reply #6 on: March 17, 2017, 10:41:11 PM »
Hello, welcome back to the forums!

I am not entirely clear about your problem: the old 11.x release builds of what was then called Simutrans-Experimental (now Simutrans-Extended) are long deprecated. The correct latest builds are the nightly builds, available here for both Windows and Linux. These latest builds do indeed support half height slopes.

The latest nightly builds will work with paksets old and new, but the newer paksets that support half-heights will only work with the new version of the executables.

As to the library issue, the nightly builds are compiled using Ubuntu 16.04, so they should be using very recent libraries. You can always compile from sources yourself if you are having trouble (use the master branch), and that is generally fairly straightforward on Linux. I should note that the .deb package has the exact same executable as is available separately.

I presume that you are running a 64-bit system?
Download Simutrans-Extended.

Want to help with development? See here for things to do for coding, and here for information on how to make graphics/objects.

Follow Simutrans-Extended on Facebook.

Offline MobRules

Re: How to avoid unsupported half-height
« Reply #7 on: March 18, 2017, 12:13:32 AM »
Yeah, my issue was that I had an ancient version :).

But I'm having trouble getting the nightly build to work.

The binary complains that it needs version 3.4.12 of the glibcxx library, whereas my system has 4.9.4 of the gcc libraries. I tried to find 3.4.12 online, but came up dry.

Attempting to compile from code resulted in:

Code: [Select]
===> CXX simsys_opengl.cc
simsys_opengl.cc: In function ‘bool dr_auto_scale(bool)’:
simsys_opengl.cc:341:3: error: expected primary-expression before ‘return’
  +return false;
   ^
simsys_opengl.cc:342:1: warning: no return statement in function returning non-void [-Wreturn-type]
 }
 ^
make: *** [common.mk:51: build/default/simsys_opengl.o] Error 1
and no executable.

(Note: I'm having health issues right now, so I'm putting less effort into troubleshooting than I normally would, and could very easily be missing something very obvious.)

Thanks for responding :)








Offline jamespetts

  • Simitrans-Extended project coordinator
  • Moderator
  • *
  • Posts: 15557
  • Total likes: 383
  • Helpful: 172
  • Cake baker
    • Bridgewater-Brunel
  • Languages: EN
Re: How to avoid unsupported half-height
« Reply #8 on: March 18, 2017, 12:18:39 AM »
Hmm - simsys_opengl.cc was part of an abortive attempt by the Standard developers to implement hardware acceleration, and it should not be one of the files that is compiled at all.

Can you check that you have correctly set up your config.default file, based on the latest config.template from the master branch?

I do hope that you feel better soon, incidentally.
Download Simutrans-Extended.

Want to help with development? See here for things to do for coding, and here for information on how to make graphics/objects.

Follow Simutrans-Extended on Facebook.

Offline MobRules

Re: How to avoid unsupported half-height
« Reply #9 on: March 18, 2017, 12:26:43 AM »
Thanks :).


I created a pastebin of my config:
http://pastebin.com/TEQnUJAs

I guess I need to choose a different $BACKEND. I used opengl because it was the only one I had / knew I had. But I can download one of the others, if necessary.

The template is from the repo I cloned off of github earlier this evening (git clone git://github.com/jamespetts/simutrans-extended) so I presume it the the most recent?


Offline jamespetts

  • Simitrans-Extended project coordinator
  • Moderator
  • *
  • Posts: 15557
  • Total likes: 383
  • Helpful: 172
  • Cake baker
    • Bridgewater-Brunel
  • Languages: EN
Re: How to avoid unsupported half-height
« Reply #10 on: March 18, 2017, 12:42:51 AM »
Ah, yes, you need preferably to use SDL2, although SDL should work, too. It should be fairly straightforward to get the SDL libraries, I think. That is the correct template apart from that.
Download Simutrans-Extended.

Want to help with development? See here for things to do for coding, and here for information on how to make graphics/objects.

Follow Simutrans-Extended on Facebook.

Offline MobRules

Re: How to avoid unsupported half-height
« Reply #11 on: March 18, 2017, 01:08:35 AM »
Looks like I have SDL2 already installed after all :). And... It compiled!

And seems to work... until it has a segmentation fault and crashes while I'm in the create new game dialog :/ (tried three times) Maybe I should compile with multithreading turned off?

Offline jamespetts

  • Simitrans-Extended project coordinator
  • Moderator
  • *
  • Posts: 15557
  • Total likes: 383
  • Helpful: 172
  • Cake baker
    • Bridgewater-Brunel
  • Languages: EN
Re: How to avoid unsupported half-height
« Reply #12 on: March 18, 2017, 01:45:09 AM »
Hmm - I did fix a crash bug earlier this evening. Did you download the latest code?
Download Simutrans-Extended.

Want to help with development? See here for things to do for coding, and here for information on how to make graphics/objects.

Follow Simutrans-Extended on Facebook.

Offline MobRules

Re: How to avoid unsupported half-height
« Reply #13 on: March 18, 2017, 02:01:22 AM »
Ah! Nope, looks like my repo is one commit behind :). I'll try again with the proper build.

Thanks!

Offline Vladki

Re: How to avoid unsupported half-height
« Reply #14 on: March 18, 2017, 08:08:43 AM »
I recommend using SDL. I had bad graphics with SDL2. You can also try builds from server.exp.simutrans.com (built on  Debian 8) they are not nightly but fresh enough to play.




Offline jamespetts

  • Simitrans-Extended project coordinator
  • Moderator
  • *
  • Posts: 15557
  • Total likes: 383
  • Helpful: 172
  • Cake baker
    • Bridgewater-Brunel
  • Languages: EN
Re: How to avoid unsupported half-height
« Reply #15 on: March 18, 2017, 11:52:34 AM »
Vladki - what was wrong with your graphics using SDL2, and how recently did you try?
Download Simutrans-Extended.

Want to help with development? See here for things to do for coding, and here for information on how to make graphics/objects.

Follow Simutrans-Extended on Facebook.

Offline MobRules

Re: How to avoid unsupported half-height
« Reply #16 on: March 18, 2017, 02:32:58 PM »
Now it only seg-faults when I try to re-size the window.  :P

Offline jamespetts

  • Simitrans-Extended project coordinator
  • Moderator
  • *
  • Posts: 15557
  • Total likes: 383
  • Helpful: 172
  • Cake baker
    • Bridgewater-Brunel
  • Languages: EN
Re: How to avoid unsupported half-height
« Reply #17 on: March 18, 2017, 03:11:29 PM »
Hmm, that's odd - are you using SDL or SDL 2?
Download Simutrans-Extended.

Want to help with development? See here for things to do for coding, and here for information on how to make graphics/objects.

Follow Simutrans-Extended on Facebook.

Offline MobRules

Re: How to avoid unsupported half-height
« Reply #18 on: March 18, 2017, 03:55:24 PM »
SDL2.

I'm also using a tiling window manager (i3), but it hasn't given me trouble with any other applications. I'm trying to get KDE properly installed so I can see if the same happens in a more normal desktop environment.

Edit: More details in how it works with i3.

True of both the regular and extended versions:
 * I open it in a fresh workspace, therefore the window automatically fills the whole screen
 * However, the window *contents* are just in the upper-left-hand corner, as though the window is not so large.

I then open a terminal in the same workspace (causing simutrans and the terminal to both be sized to half of the screen,)and then exit the terminal. Regular simutrans then actually uses the whole screen, whereas extended seg-faults as soon as I open the terminal, when it tries to re-size to half the screen.

Offline jamespetts

  • Simitrans-Extended project coordinator
  • Moderator
  • *
  • Posts: 15557
  • Total likes: 383
  • Helpful: 172
  • Cake baker
    • Bridgewater-Brunel
  • Languages: EN
Re: How to avoid unsupported half-height
« Reply #19 on: March 18, 2017, 04:02:09 PM »
That is very odd - it is hard to imagine what differences between Standard and Extended might be the cause of this. Have you tried using original SDL?
Download Simutrans-Extended.

Want to help with development? See here for things to do for coding, and here for information on how to make graphics/objects.

Follow Simutrans-Extended on Facebook.

Offline MobRules

Re: How to avoid unsupported half-height
« Reply #20 on: March 18, 2017, 09:01:01 PM »
Problem goes away when I use SDL instead of SDL2 :).

Yay! Now I can finally start really playing :D

Offline Vladki

Re: How to avoid unsupported half-height
« Reply #21 on: March 19, 2017, 10:28:14 PM »
Vladki - what was wrong with your graphics using SDL2, and how recently did you try?

See these screenshots:



Screenshots were made on Jan 26th 2017, commit hash is in the screenshot as well

To me it looks as if sdl2 does some dowscaling followed bu upscaling which makes the fonts and graphics look distorted.

Offline jamespetts

  • Simitrans-Extended project coordinator
  • Moderator
  • *
  • Posts: 15557
  • Total likes: 383
  • Helpful: 172
  • Cake baker
    • Bridgewater-Brunel
  • Languages: EN
Re: How to avoid unsupported half-height
« Reply #22 on: March 19, 2017, 11:28:29 PM »
There have been some fixes to SDL2 from Standard which I have just to-day incorporated; could you re-check with the next nightly or later to see whether this is now fixed?
Download Simutrans-Extended.

Want to help with development? See here for things to do for coding, and here for information on how to make graphics/objects.

Follow Simutrans-Extended on Facebook.